<?php

/*

 $Id: show_soa.inc,v 1.7 2004/05/26 18:07:00 philips Exp $
 $Source: /data/cvsroot/maintain/templates/show_soa.inc,v $

 Copyright (c) 2002 Oregon State University - Network Engineering
 All rights reserved.

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.


 This tools consists of three parts

 Part A) Display the SOA information (refresh, retry, etc)

 Part B) Display any NS records associated with SOA

*/

if ( $action == 'show_create' ) { 
	$current_operation = "Create SOA for $domain->name";
} 
else { 
	$domain_name = $soa->domain->name;
	$current_operation = "Update SOA for $domain_name";

	// Get the object_history information
	$history = $soa->object_history->get_history();
} 

?>
<br /><br />
<p><? $conf['error']->show_message('incomplete_form'); ?></p>

<? if ( $soa->delegated == 'true' ) { ?>

<p>Domain <b><?= $soa->domain->name ?></b> is delegated to the nameservers listed below.</p>

<p><a href="<?= $conf['web_path'] . "/soa.php?action=remove_delegation&amp;soa_id=" . $soa->id ?>">Click here to remove delegation.</a></p>

<? } else { ?>

<p><a href="<?= $conf['web_path'] . "/soa.php?action=delegate&amp;soa_id=" . $soa->id ?>">Click here to delegate this host to the nameservers listed below.</a></p>

<form name="edit_soa" enctype="multipart/form-data" method="post" action="<?= $conf['web_path']; ?>/soa.php" style="Display:inline">
<? show_template('tborder'); ?>
<table border="0" cellpadding="2" cellspacing="0" width="100%">
<tr class="widget-title">
	<td colspan="2"><?= $current_operation; ?></td>
</tr>
<? if ($action != 'show_create') { ?>
<tr bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>">
	<td title="<? $conf['help']->title('build_status'); ?>"><? $conf['help']->show_link('build_status'); ?>SOA Build Status</td>
	<td><?= $conf['ui']->show_live_time($history->date,"SOA"); ?></td>
</tr>
<tr bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>">
	<td title="<? $conf['help']->title('who_update'); ?>"><? $conf['help']->show_link('who_update'); ?>Last Updated by:</td>
	<td>
	<? 
	if ($history->username) { 
		echo $history->username . " on " . date("F j, Y", $history->date) . " at " . date("g:i a", $history->date); 
	} 
	else {
		echo "N/A";
	}
	?>
	</td>
</tr>
<? } ?>
        <tr bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>">
                <td title="<? $conf['help']->title('primary_master'); ?>"><? $conf['help']->show_link('primary_master'); ?>Primary Master: </td>
                <td><input name="primary_master" value="<? if ( $soa->primary_master ) { echo $soa->primary_master; } else { echo $conf['soa_primary_master']; } ?>" size="30" maxlength="127" />
		<? $conf['error']->show_message('primary_master'); ?>
                </td>
        </tr>
	<tr bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>">
                <td title="<? $conf['help']->title('hostmaster'); ?>"><? $conf['help']->show_link('hostmaster'); ?>Hostmaster: </td>
                <td><input name="hostmaster" value="<?  if ( $soa->hostmaster ) { echo $soa->hostmaster; } else { echo $conf['soa_hostmaster']; } ?>" size="30" maxlength="127" />
		<? $conf['error']->show_message('hostmaster'); ?>
                </td>
        </tr>
	<tr bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>">
                <td title="<? $conf['help']->title('refresh'); ?>"><? $conf['help']->show_link('refresh'); ?> Refresh: </td>
                <td><input name="refresh" value="<? if ( $soa->refresh) { echo $soa->refresh; } else { echo $conf['soa_refresh']; } ?>" size="6" maxlength="12" />
		<? $conf['error']->show_message('refresh'); ?>
                </td>
        </tr>
        <tr bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>">
                <td title="<? $conf['help']->display_plain_txt("retry"); ?>"><? $conf['help']->show_help_link('retry'); ?> Retry: </td>
                <td><input name="retry" value="<? if ( $soa->retry ) { echo $soa->retry; } else { echo $conf['soa_retry']; }?>" size="6" maxlength="12" />
                <? $conf['error']->show_message('retry'); ?>
                </td>
        </tr>
        <tr bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>">
                <td title="<? $conf['help']->display_plain_txt("expire"); ?>"><? $conf['help']->show_help_link('expire'); ?> Expire: </td>
                <td><input name="expire" value="<? if ( $soa->expire) { echo $soa->expire; } else { echo $conf['soa_expire']; }  ?>" size="6" maxlength="12" />
                <? $conf['error']->show_message('expire'); ?>
                </td>
        </tr>
        <tr bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>">
                <td title="<? $conf['help']->display_plain_txt("ttl"); ?>"><? $conf['help']->show_help_link('ttl'); ?> Negative TTL: </td>
                <td><input name="ttl" value="<? if ( $soa->ttl ) { echo $soa->ttl; } else { echo $conf['soa_ttl']; } ?>" size="6" maxlength="12" />
                <? $conf['error']->show_message('ttl'); ?>
                </td>
        </tr>
	<tr bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>">
		<td title="<? $conf['help']->title('comment'); ?>"><? $conf['help']->show_link('comment'); ?>Comment:</td>
		<td><textarea name="comment" rows="3" cols=35"><?= $comment; ?></textarea></td>
	</tr>
	<tr bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>">
		<td>&nbsp;</td>
		<td>
		<? if ( $action == 'show_create' ) { ?>
			<input type="submit" value="Create" />
			<input type="hidden" name="action" value="create_soa" />
			<input type="hidden" name="domain_id" value="<?= $domain->id ?>" />
		<? } else { ?>
			<input type="submit" name="action" value="Update" />&nbsp;&nbsp;
			<input type="submit" name="action" value="Delete" />&nbsp;&nbsp;
			<input type="submit" name="action" value="Cancel" />
			<input type="hidden" name="soa_id" value="<?= $soa->id ?>" />
		<? } ?>
		</td>
	</tr>
</table>
<? show_template('bborder'); ?>
</form>
<br /><br />
<?

/* 
 Part B) Name server information
*/

}

if ( $action != 'show_create' ) {

if ( $soa->get_nameserver_count() ) { 

// list the ns records in a table?
?>

<p><? $conf['help']->display_help("nameserver_records"); ?></p>

<? show_template('tborder'); ?>
<table border="0" cellpadding="2" cellspacing="0" width="100%">
<tr class="widget-title" bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>" align="center">
        <td>Nameserver</td>
        <td>Glue (optional)</td>
        <td>Action</td>
</tr>
<? 
	foreach ($soa->get_nameservers() as $ns) {
?>
<tr bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>" align="center">
        <td><?= $conf['ui']->display_field($ns->server); ?></td>
        <td><?= $conf['ui']->display_field($ns->glue->ip_addr); ?></td>
        <td><a href="<?= $conf['web_path']; ?>/soa.php?action=delete_nameserver&amp;ns_id=<?= $ns->id ?>&amp;soa_id=<?= $soa->id ?>" >Delete</a></td>
</tr>
<?
	}
?>
</table>
<? show_template('bborder'); ?>
<? } ?>

<br /><br />

<p><? $conf['error']->show_message('nameserver'); ?></p>

<form name="add_nameserver" enctype="multipart/form-data" method="post" action="<?= $conf['web_path']; ?>/soa.php" style="Display:inline">
<? show_template('tborder'); ?>
<table border="0" cellpadding="2" cellspacing="0" width="100%">
<tr class="widget-title" bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>">
	<td colspan="2">Add a namserver for this SOA</td>
</tr>
<tr bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>">
	<td>Nameserver:</td>
	<td><input name="nameserver" value="" size="30" maxlength="127" /></td>
</tr>
<tr bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>">
	<td>Glue (IP address):</td>
	<td><input name="glue" value="" size="18" maxlength="15" /></td>
</tr>
<tr bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>">
	<td>&nbsp;</td>
	<td>
	<input type="submit" value="Add Nameserver" />&nbsp;&nbsp;&nbsp;
	<input type="hidden" name="soa_id" value="<?= $soa->id ?>" />
	<input type="hidden" name="action" value="insert_nameserver" />
	</td>
</tr>
</table>
<? show_template('bborder'); ?>
</form>
<? } ?>
